#include <cassert>

#include <cstdlib>
using std::atoi;
using std::atof;

#include <iostream>
using std::endl;

#include <fstream>
using std::ofstream;

#include "ising.h"

#include "moments.hpp"

typedef unsigned long int counter;

int main(int argc, char* argv[])
{
	assert(argc == 3);
	const size_t L = atoi(argv[1]);
	const double T = atof(argv[2]);	
	initialize(L,T);

	const counter equilibration = 100*spin.size();
	for (counter i = 0; i < equilibration; ++i)
	{
		attempt_single_flip();
		update();
	}
	
	const counter bin_size = 100;
	const counter autocorrelation = 3*spin.size(); // 10*spin.size();
	moments mag;
	ofstream fout("mag.bins.dat",std::ios::app);
	//while(true)
	for (counter i = 0; i < 75; ++i)
	{
		mag.clear();
		for (counter m = 0; m < bin_size; ++m)
		{
			for (counter k = 0; k < autocorrelation; ++k)
			{
				attempt_single_flip();
				update();
			}
			measure(mag);
		}
		mag.print(fout,bin_size);
	}
}